<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:atom="http://purl.org/atom/ns#"
  xmlns:xhtml="http://www.w3.org/1999/xhtml"
  xmlns="http://www.w3.org/1999/xhtml">
<xsl:output indent="no" method="html" />
<xsl:output doctype-public="-//W3C//DTD HTML 4.01//EN" />
<xsl:output doctype-system="http://www.w3.org/TR/html4/strict.dtd" />
<xsl:template match="atom:feed">

<html>
<head>
  <link rel='alternate stylesheet' href='/css/blue.css' type='text/css' media='screen' title='blue' />
  <link rel='alternate stylesheet' href='/css/flashy.css' type='text/css' media='screen' title='flashy' />
  <link rel='alternate stylesheet' href='/css/outline.css' type='text/css' media='screen' title='outline' />
  <link rel='alternate stylesheet' href='/css/minimal.css' type='text/css' media='screen' title='minimal' />
  <link rel='alternate stylesheet' href='/css/guadeloupe.css' type='text/css' media='screen' title='guadeloupe' />
  <link rel='alternate stylesheet' href='/css/linuxfr.css' type='text/css' media='screen' title='linuxfr' />
  <link rel='stylesheet' href='/css/default.css' type='text/css' media='screen' title='default' />
  <link rel='stylesheet' href='/css/pda.css' type='text/css' media='handheld' title='' />
  <link rel='stylesheet' href='/css/print.css' type='text/css' media='print' title='' />
  <title>Atom: <xsl:call-template name="pagetitle"/></title>
<link rel='alternate' type='application/rss+xml' title='Fil RSS' href='http://tourmentine.com/backends/xml/tourmentine.rss' />
<link rel='alternate' type='application/atom+xml' title='Fil Atom' href='http://tourmentine.com/backends/atom/tourmentine.xml' />
<link rel='alternate' type='application/opml+xml' title='Fil OPML' href='http://tourmentine.com/backends/opml/tourmentine.opml' />

   <link rel='author' href='http://tourmentine.com/apropos.html' />
   <link rel='copyright' href='http://tourmentine.com/merci.html' />
   <link rel='home' title='HomePage' href='http://tourmentine.com' />
   <link rel='top' title='HomePage' href='http://tourmentine.com' />
   <link rel='up' title='Up' href='../' />
   <link rel='search' title='google' href='http://www.google.fr' />
   <meta http-equiv='content-language' content='fr' />
   <meta name='author' content='nicosoft' />
   <meta name='generator' content='WebLoom beta' />
</head>
<body>
<p class='back'><a href="./" accesskey="U" title="Retour  la liste des backends">[Retour]</a></p>

<!--<xsl:template match="atom:feed">-->
<div style="text-align:center"><h1>Les nouvelles anciennes de la <a href="{/atom:feed/atom:author/atom:url}">
  <xsl:value-of select="/atom:feed/atom:title"/>
</a></h1></div>
<!--</xsl:template>-->

<xsl:variable name="C" select="count(/atom:feed/atom:entry)" />
<p style="text-align:center">
  <xsl:choose>
    <xsl:when test="$C = 0" >Aucune </xsl:when>
    <xsl:when test="$C = 1" >(enfin la seule)</xsl:when>
    <xsl:otherwise>(Les <xsl:value-of select="$C" /> dernires)</xsl:otherwise>
  </xsl:choose>
</p>


<!--<div class='Items'>-->

<xsl:if test='$C = 0'>  <dt>(Empty)</dt> </xsl:if>

<xsl:for-each select="/atom:feed/atom:entry">
<div class="affnews">
<table width='100%' class='bordure'>
	<tr>
		<td align='center' class='centerhead'>
			<table width='100%' cellpadding='0' cellspacing='0' border='0'>
				<tr>
					<td class="head_1"></td>
					<td class="head_2" nowrap="nowrap"><a href="{atom:id}"><xsl:value-of select="atom:title" /></a></td>
					<td class="head_3"></td>
					<td class="head_4"></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td valign='middle' class='magicboxborder'>
			<table border='0' width='90%' class='centerbody' align="center">
			<tr>
  			<td class="centernews"><xsl:value-of disable-output-escaping="yes" select="atom:content" /></td>
			</tr></table>
		</td>
	</tr>
	<tr><td>
	<div class="foot">
		<div class="foot_1"></div>
		<div class="foot_2">Post: <xsl:value-of select="atom:modified"/></div>
		<div class="foot_3"></div>
	</div>
	</td></tr></table>
</div>

<br />

</xsl:for-each>
<!--</div>-->
<div align="right"><h6>
(MAJ <xsl:value-of select="/atom:feed/atom:modified" />)
</h6></div>
<p class='end'><a href="./" accesskey="U" title="Retour  la liste des backends">[Retour]</a></p>

<!--</div>-->
</body>
</html>
</xsl:template>
<xsl:template name="pagetitle">
<xsl:value-of select="/atom:feed/atom:title"/>
</xsl:template>

<xsl:template name="linkitem">
<xsl:value-of select="/atom:feed/atom:entry/atom:link"/>
</xsl:template>

</xsl:stylesheet>

