<?php

/*
Name: tribune.php
Author: NicoSoft
Cration: 14/08/01
MAJ      : 22/09/01
*/
require_once "include/standard.inc.php";

// renvoie les NbMsg derniers messages du fichier de tribune
function gettribunemsg($NbMsg)
{
        $File = "modules/tribune/tribune";

        if (!(file_exists("$File.csv")))
	        echo "Aucun sondage pour l'instant !<br />Attention: Fichier de sondage '$File' inexistant !!<br />";
        else
        {
        // lecture des messages
        $totmsg =  gettotal($File);
        $fd = fopen("$File.csv","r");
        fseek($fd,unstr($File,($totmsg-$NbMsg)));

        for($i=0;$i<$NbMsg+1;$i++)
        {
                $data = fgetcsv($fd, 10000, ",");
                $msgtribune[$i]["date"] = $data[0];
                $msgtribune[$i]["heure"] = $data[1];
                $msgtribune[$i]["message"] = parse_string(stripcslashes($data[2]));
        }
        fclose($fd);
        }
        return $msgtribune;
}

// poste un message dans un fichier de tribune
function writetotribune($Message)
{
        $FileName = "modules/tribune/tribune";
        $Cpt = 0;
	
        // si le fichier n'existe pas, on le cre:
        if (!file_exists("$FileName.csv") )
                createfile("$FileName.csv");

        if (!file_exists("$FileName.dat") )
                strfile($FileName);

        // ajout des messages
        if ($Message != "")
        {
                $date = strftime ("%d/%m/%Y", time());
                $string = sprintf("\"".$date."\",\"".iheure()."\",\"".$Message."\"\n");

                $fp = fopen("$FileName.csv","a");
                fwrite($fp,$string);
                fclose($fp);
                strfile($FileName);
        }
        unset($Message);
}

if ($MessageTribune != "")
        writetotribune($MessageTribune);

$Cpt = 0;

$Cpt = gettotal("modules/tribune/tribune");

// si $NbMaxPost n'est pas dfini, ou si il est plus grand que le nombre d'lments, on l'ajuste  ce nombre
if ((!isset($NbMaxPost)) || ($NbMaxPost > $Cpt))
{
        $NbMaxPost = $Cpt;
}

if ($Cpt <= 0)
{
        echo "<b>La tribune est ouverte !</b><br />";
}
else
{
        $data = gettribunemsg($NbMaxPost);

        // affichage des messages
        for($i=0;$i<$NbMaxPost;$i++)
        {
                echo "[".$data[$i]["heure"]."] ".$data[$i]["message"]."<br />\n";
        }
}

echo "<br />
<form method=get action='".caller()."'>
        <div><input name='MessageTribune' type='text' size='15'>".formcaller()."</div>
</form>";

 ?>
